#
# Copyright (c) 2016 MasterCard International Incorporated
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification, are
# permitted provided that the following conditions are met:
#
# Redistributions of source code must retain the above copyright notice, this list of
# conditions and the following disclaimer.
# Redistributions in binary form must reproduce the above copyright notice, this list of
# conditions and the following disclaimer in the documentation and/or other materials
# provided with the distribution.
# Neither the name of the MasterCard International Incorporated nor the names of its
# contributors may be used to endorse or promote products derived from this software
# without specific prior written permission.
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
# SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#


require "mastercard/core/model"
require "mastercard/core/baseobject"

module MasterCard
	module API
		module Spendcontrols
			class Channeldecline < MasterCard::Core::Model::BaseObject
				include MasterCard::Core::Model
				#

				@__store = {
					'6f4fbdb1-b67f-49ca-9e32-22aceafbdd1c' => OperationConfig.new("/issuer/spendcontrols/v1/card/{uuid}/controls/declines/channels", "delete", [], []),
					'35bbb26a-4083-4837-b846-858da34a10fb' => OperationConfig.new("/issuer/spendcontrols/v1/card/{uuid}/controls/declines/channels", "query", [], []),
					'39186fe3-fd90-4811-9038-9ce8c9bf4d09' => OperationConfig.new("/issuer/spendcontrols/v1/card/{uuid}/controls/declines/channels", "create", [], []),
					
				}

				protected

				def self.getOperationConfig(operationUUID)
					if @__store.key?(operationUUID)
						return @__store[operationUUID]
					end
					raise NotImplementedError.new("Invalid operationUUID supplied:"+ operationUUID)
				end

				def self.getOperationMetadata()
					return OperationMetadata.new(ResourceConfig.instance.getVersion(), ResourceConfig.instance.getHost(), ResourceConfig.instance.getContext(), ResourceConfig.instance.getJsonNative(), ResourceConfig.instance.getContentTypeOverride())
				end

				public





				def self.deleteById(id, map = nil)
					#Delete object of type Channeldecline by id

					#@param [String] id
					#@param [Dict] map, containing additional parameters
					#@return [Channeldecline] of the response of the deleted instance.
					#@raise [APIException] an exception from the response status


					mapObj = Channeldecline.new
					if !(id.nil? || id.to_s.empty?)
					  mapObj.set("id", id)
					end
					if !map.nil?
						if map.instance_of? RequestMap
						  mapObj.setAll(map.getObject())
						else
						  mapObj.setAll(map)
						end
					end

					return self.execute("6f4fbdb1-b67f-49ca-9e32-22aceafbdd1c", mapObj)
				end


				def delete
					#
					#Delete object of type Channeldecline

					#@param [String] id
					#@return [Channeldecline] of the response of the deleted instance.
					#@raise [APIException] an exception from the response status
					#

					return self.class.execute("6f4fbdb1-b67f-49ca-9e32-22aceafbdd1c", self)
				end









				def self.query(criteria)
					#
					#Query objects of type Channeldecline by id and optional criteria
					#@param [Dict] criteria
					#@return [Channeldecline] object representing the response.
					#@raise [APIException] an exception from the response status
					#

					return self.execute("35bbb26a-4083-4837-b846-858da34a10fb",Channeldecline.new(criteria))
				end


				def self.create(mapObj)
					#
					#Creates object of type Channeldecline
					#
					#@param Dict mapObj, containing the required parameters to create a new object
					#@return [Channeldecline] of the response of created instance.
					#@raise [APIException] an exception from the response status
					return self.execute("39186fe3-fd90-4811-9038-9ce8c9bf4d09", Channeldecline.new(mapObj))
				end







			end
		end
	end
end







