#
# Copyright (c) 2016 MasterCard International Incorporated
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification, are
# permitted provided that the following conditions are met:
#
# Redistributions of source code must retain the above copyright notice, this list of
# conditions and the following disclaimer.
# Redistributions in binary form must reproduce the above copyright notice, this list of
# conditions and the following disclaimer in the documentation and/or other materials
# provided with the distribution.
# Neither the name of the MasterCard International Incorporated nor the names of its
# contributors may be used to endorse or promote products derived from this software
# without specific prior written permission.
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
# SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
# IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#


require "mastercard/core/model"
require "mastercard/core/baseobject"

module MasterCard
	module API
		module Spendcontrols
			class Travelmarkerdecline < MasterCard::Core::Model::BaseObject
				include MasterCard::Core::Model
				#

				@__store = {
					'f66979db-696e-45e6-b564-5bbb468c1ae1' => OperationConfig.new("/issuer/spendcontrols/v1/card/{uuid}/controls/declines/travels", "create", [], []),
					'1d943b2a-ef17-4222-be51-c8cd351ad025' => OperationConfig.new("/issuer/spendcontrols/v1/card/{uuid}/controls/declines/travels", "query", [], []),
					
				}

				protected

				def self.getOperationConfig(operationUUID)
					if @__store.key?(operationUUID)
						return @__store[operationUUID]
					end
					raise NotImplementedError.new("Invalid operationUUID supplied:"+ operationUUID)
				end

				def self.getOperationMetadata()
					return OperationMetadata.new(ResourceConfig.instance.getVersion(), ResourceConfig.instance.getHost(), ResourceConfig.instance.getContext(), ResourceConfig.instance.getJsonNative(), ResourceConfig.instance.getContentTypeOverride())
				end

				public


				def self.create(mapObj)
					#
					#Creates object of type Travelmarkerdecline
					#
					#@param Dict mapObj, containing the required parameters to create a new object
					#@return [Travelmarkerdecline] of the response of created instance.
					#@raise [APIException] an exception from the response status
					return self.execute("f66979db-696e-45e6-b564-5bbb468c1ae1", Travelmarkerdecline.new(mapObj))
				end












				def self.query(criteria)
					#
					#Query objects of type Travelmarkerdecline by id and optional criteria
					#@param [Dict] criteria
					#@return [Travelmarkerdecline] object representing the response.
					#@raise [APIException] an exception from the response status
					#

					return self.execute("1d943b2a-ef17-4222-be51-c8cd351ad025",Travelmarkerdecline.new(criteria))
				end


			end
		end
	end
end







